"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CNew = exports.CCallExpression = void 0;
var ts = __importStar(require("typescript"));
var standard_1 = require("../standard");
var template_1 = require("../template");
var variable_1 = require("./variable");
var ctypes_1 = require("../types/ctypes");
var typeconvert_1 = require("./typeconvert");
var utils_1 = require("../types/utils");
var literals_1 = require("./literals");
var CCallExpression = /** @class */ (function (_super) {
    __extends(CCallExpression, _super);
    function CCallExpression(scope, call) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.funcName = null;
        _this.standardCall = null;
        _this.isSimpleClosureCall = false;
        _this.closureVarName = null;
        _this.standardCall = standard_1.StandardCallHelper.createTemplate(scope, call);
        if (_this.standardCall)
            return _this;
        // calling function that uses "this"
        var funcType = scope.root.typeHelper.getCType(call.expression);
        if (!funcType || funcType.instanceType != null) {
            _this.nodeText = call.getText();
            return _this;
        }
        _this.funcName = template_1.CodeTemplateFactory.createForNode(scope, call.expression);
        _this.arguments = call.arguments.map(function (a, i) { return funcType.parameterTypes[i] === ctypes_1.UniversalVarType ? new typeconvert_1.CAsUniversalVar(scope, a) : template_1.CodeTemplateFactory.createForNode(scope, a); });
        if (funcType.needsClosureStruct) {
            // nested calls e.g. `func(1, 2)()`;
            if (_this.funcName instanceof CCallExpression_1) {
                _this.closureVarName = scope.root.symbolsHelper.addTemp(call, "tmp_closure");
                scope.variables.push(new variable_1.CVariable(scope, _this.closureVarName, funcType));
                _this.arguments.push(_this.closureVarName);
            }
            else {
                _this.arguments.push(_this.funcName);
                _this.isSimpleClosureCall = true;
            }
        }
        else {
            var _loop_1 = function (p) {
                var parentFunc = (0, utils_1.findParentFunction)(call);
                var funcType_1 = scope.root.typeHelper.getCType(parentFunc);
                var closureVarName = funcType_1 && funcType_1.needsClosureStruct && scope.root.symbolsHelper.getClosureVarName(parentFunc);
                var value = p.node.text;
                if (closureVarName && funcType_1.closureParams.some(function (p) { return p.node.text === value; }))
                    value = closureVarName + "->scope->" + value;
                this_1.arguments.push((p.assigned ? "&" : "") + value);
            };
            var this_1 = this;
            try {
                for (var _b = __values(funcType.closureParams), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var p = _c.value;
                    _loop_1(p);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return _this;
    }
    CCallExpression_1 = CCallExpression;
    var CCallExpression_1;
    CCallExpression = CCallExpression_1 = __decorate([
        (0, template_1.CodeTemplate)("\n{#if standardCall}\n    {standardCall}\n{#elseif isSimpleClosureCall}\n    {funcName}->func({arguments {, }=> {this}})\n{#elseif closureVarName}\n    ({closureVarName} = {funcName}, {closureVarName}->func({arguments {, }=> {this}}))\n{#elseif funcName}\n    {funcName}({arguments {, }=> {this}})\n{#else}\n    /* Unsupported function call: {nodeText} */\n{/if}", ts.SyntaxKind.CallExpression)
    ], CCallExpression);
    return CCallExpression;
}(template_1.CTemplateBase));
exports.CCallExpression = CCallExpression;
var CNew = /** @class */ (function (_super) {
    __extends(CNew, _super);
    function CNew(scope, node) {
        var _this = _super.call(this) || this;
        _this.funcName = "";
        _this.allocator = "";
        _this.expression = "";
        var decl = scope.root.typeHelper.getDeclaration(node.expression);
        if (decl && ts.isIdentifier(node.expression)) {
            var funcType = scope.root.typeHelper.getCType(decl);
            _this.funcName = template_1.CodeTemplateFactory.createForNode(scope, node.expression);
            _this.arguments = node.arguments.map(function (arg) { return template_1.CodeTemplateFactory.createForNode(scope, arg); });
            var varName = scope.root.memoryManager.getReservedTemporaryVarName(node);
            if (!scope.root.memoryManager.variableWasReused(node))
                scope.variables.push(new variable_1.CVariable(scope, varName, funcType.instanceType));
            _this.arguments.unshift(varName);
            _this.allocator = new variable_1.CVariableAllocation(scope, varName, funcType.instanceType, node);
        }
        else if (ts.isIdentifier(node.expression) && node.expression.text === "Object") {
            if (node.arguments.length === 0 || (0, utils_1.isNullOrUndefined)(node.arguments[0])) {
                var objLiteral = ts.factory.createObjectLiteralExpression();
                objLiteral.parent = node;
                scope.root.typeHelper.registerSyntheticNode(objLiteral, ctypes_1.PointerVarType);
                _this.expression = new literals_1.CObjectLiteralExpression(scope, objLiteral);
            }
        }
        _this.nodeText = node.getText();
        return _this;
    }
    CNew = __decorate([
        (0, template_1.CodeTemplate)("\n{#statements}\n    {allocator}\n{/statements}\n{#if funcName}\n    {funcName}({arguments {, }=> {this}})\n{#elseif expression}\n    {expression}\n{#else}\n    /* Unsupported 'new' expression {nodeText} */\n{/if}", ts.SyntaxKind.NewExpression)
    ], CNew);
    return CNew;
}(template_1.CTemplateBase));
exports.CNew = CNew;
//# sourceMappingURL=call.js.map