"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CFunctionExpression = exports.CFunction = exports.CFunctionPrototype = void 0;
var ts = __importStar(require("typescript"));
var template_1 = require("../template");
var variable_1 = require("./variable");
var ctypes_1 = require("../types/ctypes");
var standard_1 = require("../standard");
var utils_1 = require("../types/utils");
var CFunctionPrototype = /** @class */ (function (_super) {
    __extends(CFunctionPrototype, _super);
    function CFunctionPrototype(scope, node) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.parameters = [];
        var funcType = scope.root.typeHelper.getCType(node);
        _this.returnType = scope.root.typeHelper.getTypeString(funcType.returnType);
        _this.name = node.name.getText();
        _this.parameters = node.parameters.map(function (p, i) { return new variable_1.CVariable(scope, p.name.getText(), funcType.parameterTypes[i], { removeStorageSpecifier: true }); });
        if (funcType.instanceType)
            _this.parameters.unshift(new variable_1.CVariable(scope, "this", funcType.instanceType, { removeStorageSpecifier: true }));
        try {
            for (var _b = __values(funcType.closureParams), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                _this.parameters.push(new variable_1.CVariable(scope, p.node.text, p.node, { removeStorageSpecifier: true }));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return _this;
    }
    CFunctionPrototype = __decorate([
        (0, template_1.CodeTemplate)("{returnType} {name}({parameters {, }=> {this}});")
    ], CFunctionPrototype);
    return CFunctionPrototype;
}(template_1.CTemplateBase));
exports.CFunctionPrototype = CFunctionPrototype;
var CFunction = /** @class */ (function (_super) {
    __extends(CFunction, _super);
    function CFunction(root, node) {
        var e_2, _a, e_3, _b;
        var _this = _super.call(this) || this;
        _this.root = root;
        _this.func = _this;
        _this.parameters = [];
        _this.variables = [];
        _this.scopeVarAllocator = null;
        _this.statements = [];
        _this.parent = root;
        _this.name = node.name && node.name.text;
        if (!_this.name) {
            var funcExprName = "func";
            if ((0, utils_1.isEqualsExpression)(node.parent) && node.parent.right == node && ts.isIdentifier(node.parent.left))
                funcExprName = node.parent.left.text + "_func";
            if (ts.isVariableDeclaration(node.parent) && node.parent.initializer == node && ts.isIdentifier(node.parent.name))
                funcExprName = node.parent.name.text + "_func";
            if (ts.isPropertyAssignment(node.parent) && ts.isIdentifier(node.parent.name))
                funcExprName = node.parent.name.text + "_func";
            _this.name = root.symbolsHelper.addTemp((0, utils_1.findParentSourceFile)(node), funcExprName);
        }
        var funcType = root.typeHelper.getCType(node);
        _this.funcDecl = new variable_1.CVariable(_this, _this.name, funcType.returnType, { removeStorageSpecifier: true, arraysToPointers: true, funcDecl: true });
        _this.parameters = node.parameters.map(function (p, i) {
            return new variable_1.CVariable(_this, p.name.text, funcType.parameterTypes[i], { removeStorageSpecifier: true });
        });
        if (funcType.instanceType)
            _this.parameters.unshift(new variable_1.CVariable(_this, "this", funcType.instanceType, { removeStorageSpecifier: true }));
        if (funcType.needsClosureStruct) {
            var closureParamVarName = root.symbolsHelper.getClosureVarName(node);
            _this.parameters.push(new variable_1.CVariable(_this, closureParamVarName, funcType));
        }
        else {
            try {
                for (var _c = __values(funcType.closureParams), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var p = _d.value;
                    var type = root.typeHelper.getCType(p.node);
                    var ptype = p.assigned ? (0, ctypes_1.getTypeText)(type) + "*" : type;
                    _this.parameters.push(new variable_1.CVariable(_this, p.node.text, ptype, { removeStorageSpecifier: true }));
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        if (funcType.scopeType) {
            var scopeVarName = root.symbolsHelper.getScopeVarName(node);
            _this.variables.push(new variable_1.CVariable(_this, scopeVarName, funcType.scopeType));
            _this.scopeVarAllocator = new variable_1.CVariableAllocation(_this, scopeVarName, funcType.scopeType, node);
        }
        _this.gcVarNames = root.memoryManager.getGCVariablesForScope(node);
        var _loop_1 = function (gcVarName) {
            if (root.variables.filter(function (v) { return v.name == gcVarName; }).length)
                return "continue";
            var gcType = "ARRAY(void *)";
            if (gcVarName.indexOf("_arrays") > -1)
                gcType = "ARRAY(ARRAY(void *))";
            if (gcVarName.indexOf("_arrays_c") > -1)
                gcType = "ARRAY(ARRAY(ARRAY(void *)))";
            if (gcVarName.indexOf("_dicts") > -1)
                gcType = "ARRAY(DICT(void *))";
            root.variables.push(new variable_1.CVariable(root, gcVarName, gcType));
        };
        try {
            for (var _e = __values(_this.gcVarNames), _f = _e.next(); !_f.done; _f = _e.next()) {
                var gcVarName = _f.value;
                _loop_1(gcVarName);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_3) throw e_3.error; }
        }
        node.body.statements.forEach(function (s) { return _this.statements.push(template_1.CodeTemplateFactory.createForNode(_this, s)); });
        if (node.body.statements.length > 0 && node.body.statements[node.body.statements.length - 1].kind != ts.SyntaxKind.ReturnStatement) {
            _this.destructors = new variable_1.CVariableDestructors(_this, node);
        }
        var nodesInFunction = (0, utils_1.getAllNodesUnder)(node);
        var declaredFunctionNames = root.functions.concat(root.functionPrototypes).map(function (f) { return f.name; });
        nodesInFunction.filter(function (n) { return ts.isCallExpression(n) && !standard_1.StandardCallHelper.isStandardCall(root.typeHelper, n); })
            .forEach(function (c) {
            if (ts.isIdentifier(c.expression) && declaredFunctionNames.indexOf(c.expression.text) === -1) {
                var decl = root.typeHelper.getDeclaration(c.expression);
                if (decl && decl !== node && ts.isFunctionDeclaration(decl)) {
                    root.functionPrototypes.push(new CFunctionPrototype(root, decl));
                    declaredFunctionNames.push(decl.name.text);
                }
            }
        });
        return _this;
    }
    CFunction = __decorate([
        (0, template_1.CodeTemplate)("\n{funcDecl}({parameters {, }=> {this}})\n{\n    {variables  {    }=> {this};\n}\n\n    {#if scopeVarAllocator != null}\n        {scopeVarAllocator}\n    {/if}\n\n    {gcVarNames {    }=> ARRAY_CREATE({this}, 2, 0);\n}\n\n    {statements {    }=> {this}}\n\n    {destructors}\n}")
    ], CFunction);
    return CFunction;
}(template_1.CTemplateBase));
exports.CFunction = CFunction;
var CFunctionExpression = /** @class */ (function (_super) {
    __extends(CFunctionExpression, _super);
    function CFunctionExpression(scope, node) {
        var _this = _super.call(this) || this;
        _this.expression = '';
        _this.isClosureFunc = false;
        var type = scope.root.typeHelper.getCType(node);
        var parentFunc = (0, utils_1.findParentFunction)(node.parent);
        if (type instanceof ctypes_1.FuncType && type.needsClosureStruct && parentFunc) {
            var parentFuncType = scope.root.typeHelper.getCType(parentFunc);
            _this.isClosureFunc = true;
            _this.closureVarName = scope.root.memoryManager.getReservedTemporaryVarName(node);
            scope.root.symbolsHelper.ensureClosureStruct(type, parentFuncType, _this.closureVarName);
            if (!scope.root.memoryManager.variableWasReused(node))
                scope.variables.push(new variable_1.CVariable(scope, _this.closureVarName, type));
            _this.allocator = new variable_1.CVariableAllocation(scope, _this.closureVarName, type, node);
            /** since we're anyway passing the whole scope object, probably a good idea to move this fragment into @see CFunction */
            _this.scopeVarName = parentFuncType && scope.root.symbolsHelper.getScopeVarName(node);
            var parentClosureVarName = parentFuncType && parentFuncType.needsClosureStruct && scope.root.symbolsHelper.getClosureVarName(parentFunc);
            var prefix_1 = parentClosureVarName ? parentClosureVarName + "->scope->" : "";
            var closureParamsFromParent = parentFuncType.closureParams.map(function (p) { return ({ key: p.node.text, value: prefix_1 + p.node.text }); });
            var paramsFromParent = type.closureParams.filter(function (p) { return scope.root.typeHelper.getDeclaration(p.node).parent === parentFunc; }).map(function (p) { return ({ key: p.node.text, value: p.node.text }); });
            _this.closureParams = closureParamsFromParent.concat(paramsFromParent);
        }
        var func = new CFunction(scope.root, node);
        scope.root.functions.push(func);
        _this.name = func.name;
        if (ts.isFunctionExpression(node))
            _this.expression = _this.closureVarName || func.name;
        return _this;
    }
    CFunctionExpression = __decorate([
        (0, template_1.CodeTemplate)("\n{#statements}\n    {#if isClosureFunc}\n        {closureParams => {scopeVarName}->{key} = {value};\n}\n        {allocator}\n        {closureVarName}->func = {name};\n        {closureVarName}->scope = {scopeVarName};\n    {/if}\n{/statements}\n{expression}", [ts.SyntaxKind.FunctionExpression, ts.SyntaxKind.FunctionDeclaration])
    ], CFunctionExpression);
    return CFunctionExpression;
}(template_1.CTemplateBase));
exports.CFunctionExpression = CFunctionExpression;
//# sourceMappingURL=function.js.map