"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CircularTypesFinder = void 0;
var ts = __importStar(require("typescript"));
var utils_1 = require("./utils");
var CircularTypesFinder = /** @class */ (function () {
    function CircularTypesFinder(allNodes, typeChecker) {
        this.allNodes = allNodes;
        this.typeChecker = typeChecker;
        this.assignments = {};
        this.circularAssignments = {};
    }
    CircularTypesFinder.prototype.findCircularAssignments = function () {
        var e_1, _a;
        this.circularAssignments = {};
        this.assignments = {};
        try {
            for (var _b = __values(this.allNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
                var node = _c.value;
                if ((0, utils_1.isEqualsExpression)(node) || ts.isVariableDeclaration(node)) {
                    var left = (0, utils_1.isEqualsExpression)(node) ? node.left : node.name;
                    var right = (0, utils_1.isEqualsExpression)(node) ? node.right : node.initializer;
                    if (!left || !right)
                        continue;
                    var lvar = left;
                    var leftProps = [];
                    while ((0, utils_1.isFieldPropertyAccess)(lvar) || (0, utils_1.isFieldElementAccess)(lvar)) {
                        if ((0, utils_1.isFieldPropertyAccess)(lvar))
                            leftProps.unshift(lvar.name.text);
                        else if ((0, utils_1.isFieldElementAccess)(lvar))
                            leftProps.unshift(lvar.argumentExpression.getText().slice(1, -1));
                        lvar = lvar.expression;
                    }
                    this.checkOneAssignment(node, lvar, leftProps, right);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        console.log(Object.keys(this.circularAssignments));
        return this.circularAssignments;
    };
    CircularTypesFinder.prototype.checkOneAssignment = function (refNode, left, leftProps, right) {
        var e_2, _a;
        var _this = this;
        if (ts.isObjectLiteralExpression(right)) {
            try {
                for (var _b = __values(right.properties), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var prop = _c.value;
                    if (ts.isPropertyAssignment(prop) && ts.isIdentifier(prop.name))
                        this.checkOneAssignment(refNode, left, leftProps.concat(prop.name.text), prop.initializer);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return;
        }
        var rightProps = [];
        while ((0, utils_1.isFieldPropertyAccess)(right) || (0, utils_1.isFieldElementAccess)(right)) {
            if ((0, utils_1.isFieldPropertyAccess)(right))
                rightProps.unshift(right.name.text);
            else if ((0, utils_1.isFieldElementAccess)(right))
                rightProps.unshift(right.argumentExpression.getText().slice(1, -1));
            right = right.expression;
        }
        var symbolRight = this.typeChecker.getSymbolAtLocation(right);
        var symbolLeft = this.typeChecker.getSymbolAtLocation(left);
        if (symbolRight && symbolLeft) {
            var key_1 = symbolLeft.valueDeclaration.pos + "->" + leftProps.map(function (p) { return p + "->"; }).join("");
            var value_1 = symbolRight.valueDeclaration.pos + "->" + rightProps.map(function (p) { return p + "->"; }).join("");
            if (key_1.indexOf(value_1) === 0 || Object.keys(this.assignments).filter(function (k) { return k.indexOf(value_1) === 0; }).some(function (k) { return _this.assignments[k].some(function (a) { return key_1.indexOf(a) === 0; }); }))
                this.circularAssignments[refNode.pos] = { node: symbolLeft.valueDeclaration, propChain: leftProps };
            this.assignments[key_1] = (this.assignments[key_1] || []).concat(value_1);
        }
    };
    return CircularTypesFinder;
}());
exports.CircularTypesFinder = CircularTypesFinder;
//# sourceMappingURL=findcircular.js.map