"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyntaxKind_NaNKeyword = void 0;
exports.isNode = isNode;
exports.isEqualsExpression = isEqualsExpression;
exports.isFieldAssignment = isFieldAssignment;
exports.isMethodCall = isMethodCall;
exports.isFunction = isFunction;
exports.isFunctionArgInMethodCall = isFunctionArgInMethodCall;
exports.isFieldElementAccess = isFieldElementAccess;
exports.isFieldPropertyAccess = isFieldPropertyAccess;
exports.isForOfWithSimpleInitializer = isForOfWithSimpleInitializer;
exports.isForOfWithIdentifierInitializer = isForOfWithIdentifierInitializer;
exports.isLiteral = isLiteral;
exports.isUnaryExpression = isUnaryExpression;
exports.isNullOrUndefinedOrNaN = isNullOrUndefinedOrNaN;
exports.isNullOrUndefined = isNullOrUndefined;
exports.isDeleteExpression = isDeleteExpression;
exports.isThisKeyword = isThisKeyword;
exports.isCompoundAssignment = isCompoundAssignment;
exports.isNumberOp = isNumberOp;
exports.isIntegerOp = isIntegerOp;
exports.isRelationalOp = isRelationalOp;
exports.isEqualityOp = isEqualityOp;
exports.isLogicOp = isLogicOp;
exports.isPlusOp = isPlusOp;
exports.isStringLiteralAsIdentifier = isStringLiteralAsIdentifier;
exports.isInBoolContext = isInBoolContext;
exports.isSimpleNode = isSimpleNode;
exports.isSideEffectExpression = isSideEffectExpression;
exports.operandsToNumber = operandsToNumber;
exports.getBinExprResultType = getBinExprResultType;
exports.getUnaryExprResultType = getUnaryExprResultType;
exports.toNumberCanBeNaN = toNumberCanBeNaN;
exports.toPrimitive = toPrimitive;
exports.findParentFunction = findParentFunction;
exports.findParentSourceFile = findParentSourceFile;
exports.getAllFunctionNodesInFunction = getAllFunctionNodesInFunction;
exports.getAllNodesInFunction = getAllNodesInFunction;
exports.getAllNodesUnder = getAllNodesUnder;
exports.isUnder = isUnder;
exports.hasType = hasType;
var ts = __importStar(require("typescript"));
var ctypes_1 = require("./ctypes");
function isNode(n) {
    return n && n.kind !== undefined && n.flags !== undefined && n.pos !== undefined && n.end !== undefined;
}
function isEqualsExpression(n) {
    return n && n.kind == ts.SyntaxKind.BinaryExpression && n.operatorToken.kind == ts.SyntaxKind.EqualsToken;
}
function isFieldAssignment(n) {
    return n && n.kind == ts.SyntaxKind.BinaryExpression && n.operatorToken.kind == ts.SyntaxKind.EqualsToken && (isFieldElementAccess(n.left) || isFieldPropertyAccess(n.left));
}
function isMethodCall(n) {
    return ts.isCallExpression(n) && ts.isPropertyAccessExpression(n.expression);
}
function isFunction(n) {
    return ts.isFunctionDeclaration(n) || ts.isFunctionExpression(n);
}
function isFunctionArgInMethodCall(n) {
    return ts.isFunctionExpression(n) && ts.isCallExpression(n.parent) && n.parent.arguments[0] == n && ts.isPropertyAccessExpression(n.parent.expression);
}
function isFieldElementAccess(n) {
    return ts.isElementAccessExpression(n) && (!ts.isCallExpression(n.parent) || n.parent.expression != n);
}
function isFieldPropertyAccess(n) {
    return ts.isPropertyAccessExpression(n) && (!ts.isCallExpression(n.parent) || n.parent.expression != n);
}
function isForOfWithSimpleInitializer(n) {
    return ts.isForOfStatement(n) && ts.isVariableDeclarationList(n.initializer) && n.initializer.declarations.length == 1;
}
function isForOfWithIdentifierInitializer(n) {
    return ts.isForOfStatement(n) && ts.isIdentifier(n.initializer);
}
function isLiteral(n) {
    return ts.isNumericLiteral(n) || ts.isStringLiteral(n) || ts.isRegularExpressionLiteral(n) || n.kind == ts.SyntaxKind.TrueKeyword || n.kind == ts.SyntaxKind.FalseKeyword;
}
function isUnaryExpression(n) {
    return ts.isPrefixUnaryExpression(n) || ts.isPostfixUnaryExpression(n);
}
exports.SyntaxKind_NaNKeyword = ts.SyntaxKind.Count + 1;
function isNullOrUndefinedOrNaN(n) {
    return n.kind === ts.SyntaxKind.NullKeyword || n.kind === ts.SyntaxKind.UndefinedKeyword || n.kind === exports.SyntaxKind_NaNKeyword;
}
function isNullOrUndefined(n) {
    return n.kind === ts.SyntaxKind.NullKeyword || n.kind === ts.SyntaxKind.UndefinedKeyword;
}
function isDeleteExpression(n) {
    return ts.isDeleteExpression(n) && (ts.isPropertyAccessExpression(n.expression) || ts.isElementAccessExpression(n.expression));
}
function isThisKeyword(n) {
    return n.kind === ts.SyntaxKind.ThisKeyword;
}
function isCompoundAssignment(n) {
    if (ts.isBinaryExpression(n))
        return n.operatorToken.kind >= ts.SyntaxKind.FirstCompoundAssignment && n.operatorToken.kind <= ts.SyntaxKind.LastCompoundAssignment;
    else
        return n.kind >= ts.SyntaxKind.FirstCompoundAssignment && n.kind <= ts.SyntaxKind.LastCompoundAssignment;
}
function isNumberOp(op) {
    return [
        ts.SyntaxKind.MinusToken, ts.SyntaxKind.MinusEqualsToken,
        ts.SyntaxKind.AsteriskToken, ts.SyntaxKind.AsteriskEqualsToken,
        ts.SyntaxKind.SlashToken, ts.SyntaxKind.SlashEqualsToken,
        ts.SyntaxKind.PercentToken, ts.SyntaxKind.PercentEqualsToken,
    ].indexOf(op) > -1;
}
function isIntegerOp(op) {
    return [
        ts.SyntaxKind.LessThanLessThanToken, ts.SyntaxKind.LessThanLessThanEqualsToken,
        ts.SyntaxKind.GreaterThanGreaterThanToken, ts.SyntaxKind.GreaterThanGreaterThanEqualsToken,
        ts.SyntaxKind.GreaterThanGreaterThanGreaterThanToken, ts.SyntaxKind.GreaterThanGreaterThanGreaterThanEqualsToken,
        ts.SyntaxKind.BarToken, ts.SyntaxKind.BarEqualsToken,
        ts.SyntaxKind.AmpersandToken, ts.SyntaxKind.AmpersandEqualsToken
    ].indexOf(op) > -1;
}
function isRelationalOp(op) {
    return [
        ts.SyntaxKind.LessThanToken, ts.SyntaxKind.LessThanEqualsToken,
        ts.SyntaxKind.GreaterThanToken, ts.SyntaxKind.GreaterThanEqualsToken
    ].indexOf(op) > -1;
}
function isEqualityOp(op) {
    return [
        ts.SyntaxKind.EqualsEqualsToken, ts.SyntaxKind.EqualsEqualsEqualsToken,
        ts.SyntaxKind.ExclamationEqualsToken, ts.SyntaxKind.ExclamationEqualsEqualsToken,
    ].indexOf(op) > -1;
}
function isLogicOp(op) {
    return [
        ts.SyntaxKind.BarBarToken, ts.SyntaxKind.AmpersandAmpersandToken
    ].indexOf(op) > -1;
}
function isPlusOp(op) {
    return op == ts.SyntaxKind.PlusToken || op == ts.SyntaxKind.PlusEqualsToken;
}
function isStringLiteralAsIdentifier(n) {
    return ts.isStringLiteral(n) && /^[A-Za-z_][A-Za-z_0-9]*$/.test(n.text);
}
function isInBoolContext(n) {
    while (ts.isBinaryExpression(n.parent) && isLogicOp(n.parent.operatorToken.kind))
        n = n.parent;
    return ts.isPrefixUnaryExpression(n.parent) && n.parent.operator === ts.SyntaxKind.ExclamationToken
        || ts.isIfStatement(n.parent) && n.parent.expression === n
        || ts.isWhileStatement(n.parent) && n.parent.expression === n
        || ts.isDoStatement(n.parent) && n.parent.expression === n
        || ts.isForStatement(n.parent) && n.parent.condition === n;
}
function isSimpleNode(n) {
    return ts.isStringLiteral(n) || ts.isNumericLiteral(n) || ts.isIdentifier(n);
}
function isSideEffectExpression(n) {
    return isEqualsExpression(n) || isCompoundAssignment(n)
        || isUnaryExpression(n) && n.operator === ts.SyntaxKind.PlusPlusToken
        || isUnaryExpression(n) && n.operator === ts.SyntaxKind.MinusMinusToken
        || ts.isCallExpression(n)
        || ts.isNewExpression(n);
}
function operandsToNumber(leftType, op, rightType) {
    return isNumberOp(op) || isIntegerOp(op)
        || op == ts.SyntaxKind.PlusToken && !toNumberCanBeNaN(leftType) && !toNumberCanBeNaN(rightType)
        || isRelationalOp(op) && (leftType !== ctypes_1.StringVarType || rightType !== ctypes_1.StringVarType);
}
function getBinExprResultType(mergeTypes, leftType, op, rightType) {
    if (op === ts.SyntaxKind.EqualsToken)
        return rightType;
    if (isRelationalOp(op) || isEqualityOp(op) || op === ts.SyntaxKind.InKeyword || op === ts.SyntaxKind.InstanceOfKeyword)
        return ctypes_1.BooleanVarType;
    if (leftType == null || rightType == null)
        return null;
    if (isLogicOp(op))
        return mergeTypes(leftType, rightType).type;
    if (isNumberOp(op) || isIntegerOp(op))
        return toNumberCanBeNaN(leftType) || toNumberCanBeNaN(rightType) ? ctypes_1.UniversalVarType : ctypes_1.NumberVarType;
    if (op === ts.SyntaxKind.PlusToken || op === ts.SyntaxKind.PlusEqualsToken)
        return leftType === ctypes_1.UniversalVarType || rightType === ctypes_1.UniversalVarType ? ctypes_1.UniversalVarType
            : toPrimitive(leftType) === ctypes_1.StringVarType || toPrimitive(rightType) === ctypes_1.StringVarType ? ctypes_1.StringVarType
                : toPrimitive(leftType) === ctypes_1.NumberVarType && toPrimitive(rightType) == ctypes_1.NumberVarType ? ctypes_1.NumberVarType
                    : null;
    console.log("WARNING: unexpected binary expression!");
    return null;
}
function getUnaryExprResultType(op, operandType) {
    if (op === ts.SyntaxKind.ExclamationToken) {
        return ctypes_1.BooleanVarType;
    }
    else if (op === ts.SyntaxKind.TildeToken) {
        return ctypes_1.NumberVarType;
    }
    else {
        return toNumberCanBeNaN(operandType) ? ctypes_1.UniversalVarType : ctypes_1.NumberVarType;
    }
}
function toNumberCanBeNaN(t) {
    return t !== null && t !== ctypes_1.PointerVarType && t !== ctypes_1.NumberVarType && t !== ctypes_1.BooleanVarType && !(t instanceof ctypes_1.ArrayType && !t.isDynamicArray && t.capacity == 1 && !toNumberCanBeNaN(t.elementType));
}
function toPrimitive(t) {
    return t === null || t === ctypes_1.PointerVarType ? t : t === ctypes_1.NumberVarType || t === ctypes_1.BooleanVarType ? ctypes_1.NumberVarType : ctypes_1.StringVarType;
}
function findParentFunction(node) {
    var parentFunc = node;
    while (parentFunc && !isFunction(parentFunc))
        parentFunc = parentFunc.parent;
    return parentFunc;
}
function findParentSourceFile(node) {
    var parent = node;
    while (!ts.isSourceFile(parent))
        parent = parent.parent;
    return parent;
}
function getAllFunctionNodesInFunction(node) {
    var nodes = __spreadArray([], __read(node.getChildren()), false);
    var foundFuncNodes = [];
    var cur;
    while (cur = nodes.shift()) {
        if (ts.isFunctionLike(cur)) {
            foundFuncNodes.push(cur);
        }
        else
            nodes.push.apply(nodes, cur.getChildren());
    }
    return foundFuncNodes;
}
function getAllNodesInFunction(node) {
    var i = 0;
    var nodes = __spreadArray([], __read(node.getChildren()), false);
    while (i < nodes.length) {
        if (ts.isFunctionLike(nodes[i]))
            i++;
        else
            nodes.push.apply(nodes, nodes[i++].getChildren());
    }
    return nodes;
}
function getAllNodesUnder(node) {
    var i = 0;
    var nodes = [node];
    while (i < nodes.length)
        nodes.push.apply(nodes, nodes[i++].getChildren());
    return nodes;
}
function isUnder(container, item) {
    var parent = item;
    while (parent && parent != container)
        parent = parent.parent;
    return parent;
}
function hasType(refType, type) {
    return refType == type
        || refType instanceof ctypes_1.StructType && Object.keys(refType.properties).some(function (k) { return hasType(refType.properties[k], type); })
        || refType instanceof ctypes_1.ArrayType && hasType(refType.elementType, type)
        || refType instanceof ctypes_1.DictType && hasType(refType.elementType, type)
        || refType instanceof ctypes_1.FuncType && hasType(refType.returnType, type)
        || refType instanceof ctypes_1.FuncType && hasType(refType.instanceType, type)
        || refType instanceof ctypes_1.FuncType && refType.parameterTypes.some(function (pt) { return hasType(pt, type); });
}
//# sourceMappingURL=utils.js.map